// oZ싅 (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size) {

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos {
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[]) {

	char fname[FILENAME_MAX];
	int i,d;

	// Disk A
	struct fpos md1[] = {
		{ 0x38, 0x01, 0x0200 },	// K΂₵
		{ 0x38, 0x03, 0x0200 },	// i
		{ 0x38, 0x05, 0x0200 },	// ʘH
		{ 0x38, 0x07, 0x0100 },
		{ 0x38, 0x08, 0x0200 },	// Vࣖ
		{ 0x38, 0x0a, 0x0100 },	// 
		{ 0x38, 0x0b, 0x0500 },	// 
		{ 0x38, 0x10, 0x0100 },	// j}
		{ 0x39, 0x01, 0x0200 },	// V2 MODE ONLY (ꂾItZbgF4`)
		{ 0x39, 0x03, 0x0200 },	// t
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	// Disk B
	struct fpos md2[] = {
		{ 0x3d, 0x07, 0x0200 },	// 炬
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	// ADPCM Data (Disk 1)
	struct fpos pd1[] = {
		{ 0x3e, 0x01, 0x1500 },	// bL[			00 1500-1A00
		{ 0x3f, 0x05, 0x1b00 },	// Ƃ܂Ă	01 0000-0690
		{ 0x40, 0x10, 0x2600 },	// o[X			02 0C00-1600
		{ 0x43, 0x06, 0x1b00 },	// ߂łƂ		03 1B00-2300
		{ 0x45, 0x01, 0x1d00 },	// 				04 2300-2600
		{ 0x46, 0x0e, 0x2600 },	// `FbN			05 2600-2C00
		{ 0x4a, 0x01, 0x4d00 },	// 				06 2C00-3F00
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	// ADPCM Data (Disk 2)
	struct fpos pd2[] = {
		{ 0x02, 0x01, 0x3900 },	// ?				07 3F00-4B00
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x02, 0x01, 0x00, 0x01, 0x01, buff, 0x100);
		switch (*buff) {
		case 0xc3:
			printf("Disk A F܂.\n");
			fcut("MUSDRV", 0x01, 0x00, 0x01, 0x02, 0x01, 0x0000, 0x0f00);
			fcut("PCMDRV", 0x12, 0x09, 0x00, 0x01, 0x01, 0x0000, 0x1000);

			// ȃf[^̐؂o
			for (i=0; md1[i].sec; i++) {
				sprintf(fname,"MUS1%02d",i);
				fcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x01, 0x0000, md1[i].size);
			}
			// ADPCMf[^̐؂o
			for (i=0; pd1[i].sec; i++) {
				sprintf(fname,"ADPCM1%02d",i);
				fcut(fname, pd1[i].trk, pd1[i].trk>>1, pd1[i].trk&1, pd1[i].sec, 0x01, 0x0000, pd1[i].size);
			}
			continue;

		case 0x08:
			printf("Disk B F܂.\n");
			// ȃf[^̐؂o
			for (i=0; md2[i].sec; i++) {
				sprintf(fname,"MUS2%02d",i);
				fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x01, 0x0000, md2[i].size);
			}
			// ADPCMf[^̐؂o
			for (i=0; pd2[i].sec; i++) {
				sprintf(fname,"ADPCM2%02d",i);
				fcut(fname, pd2[i].trk, pd2[i].trk>>1, pd2[i].trk&1, pd2[i].sec, 0x01, 0x0000, pd2[i].size);
			}
			continue;

		}
	}
	return 0;
}

